package sax.htmlcreate;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class HtmlCreateHandler extends DefaultHandler {
   
   String lastElement;// Save name of last visited element
   
   @Override public void startDocument() throws SAXException {
      print("<html xmlns='http://www.w3.org/1999/xhtml'>\n" 
          + "  <head><title>A Memo</title></head>\n"
          + "  <body>\n"
          + "    <dl>\n"
          + "      <dt>Sender:</dt>"); // <from> content follows ...
   }
   
   @Override
   public void startElement(String uri, String localName, String qName,
         Attributes attributes) throws SAXException {
      lastElement = qName;
   }
   
   @Override
   public void characters(char[] ch, int start, int length) throws SAXException {
      final String content = new String(ch, start, length).trim();
      if (0 < content.length()) {
         switch(lastElement) {
         case "from":    print("      <dd>" + content + "</dd>\n"
                           +   "      <dt>Recipients:</dt>\n"
                           +   "      <dd>\n" 
                           +   "        <ul>");
            break;
         case "to":      print("          <li>" + content + "</li>");
            break;
         case "subject": print("        </ul>\n"
                           +   "      </dd>\n"
                           +   "    </dl>");
            break;
         case "content":
            break;
            
            default:     print("unexpected content:" + content);
         }
      }
   }
   
   @Override public void endDocument() throws SAXException {
      print("  </body>\n"
                        +"</html>\n"); 
   }
   
   // Shortcut System.out.println
   private void print(final String s) { System.out.println(s);}
}