package sax.htmlcreate;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

/** Parser, content- and errorhandler assembly */
public class Memo2Html {
  /** @throws SAXException
   *  @throws ParserConfigurationException */
  public Memo2Html()
   throws SAXException, ParserConfigurationException{
      final SAXParserFactory saxPf = SAXParserFactory.newInstance();
      final SAXParser saxParser = saxPf.newSAXParser();
      xmlReader = saxParser.getXMLReader();
      xmlReader.setContentHandler(eventHandler);
      xmlReader.setErrorHandler(errorHandler);
  }
  /** @see sax.stat.v1.ElementCount
   * @param uri
   * @throws IOException
   * @throws SAXException */
  public void parse(final String uri) 
    throws IOException, SAXException{
    xmlReader.parse(uri);
  }

  private final XMLReader xmlReader;
  private final HtmlCreateHandler eventHandler = new HtmlCreateHandler();
  private final MyErrorHandler errorHandler = new MyErrorHandler();
}